package ch.unige.solidify.test.specification.dao;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

public class EntityMockSpecification implements Specification<EntityMock> {
  private static final long serialVersionUID = 8535594096558989092L;
  private final EntityMock criteria;

  public EntityMockSpecification(EntityMock criteria) {
    this.criteria = criteria;
  }

  @Override
  public Predicate toPredicate(Root<EntityMock> root, CriteriaQuery<?> criteriaQuery,
          CriteriaBuilder criteriaBuilder) {
    final List<Predicate> listPredicate = new ArrayList<>();
    if (this.criteria.getLabel() != null) {
      listPredicate.add(criteriaBuilder
              .like(root.get("label"), "%" + this.criteria.getLabel() + "%"));
    }
    return criteriaBuilder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
  }
}
